diff --git a/tests/lowalgos/classifier/bug28211_22 b/tests/lowalgos/classifier/bug28211_22
new file mode 100644
index 0000000..82cc06e
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_22
@@ -0,0 +1,38 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The face is trivial (without any specialities).
+# The result of classification must be ON.
+
+set Toler 1.0e-7
+
+binrestore [locate_data_file bug28211_trivialface.brep] result
+
+checkshape result
+
+point pp 1.0000000000000000 0.00010995037190202700
+
+if { ![regexp {ON} [ b2dclassifx result pp -t $Toler] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {ON} [ b2dclassify result pp -t $Toler] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/classifier/bug28211_23 b/tests/lowalgos/classifier/bug28211_23
new file mode 100644
index 0000000..c32232d
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_23
@@ -0,0 +1,30 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The face contains gaps. However, these gaps are between curves only.
+# All vertices are in the ends of correspond curves.
+# Therefore, algorithm based on BRep_Tool::UVPoints does not create
+# pseudo-edges.
+
+binrestore [locate_data_file bug28211_notpseudogaps.bin] result
+
+checkshape result
+
+if { ![regexp {not hole} [ ishole result  ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/classifier/bug28211_24 b/tests/lowalgos/classifier/bug28211_24
new file mode 100644
index 0000000..6a2f738
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_24
@@ -0,0 +1,41 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The source face is trivial, based on planar surface but is invalid
+# in terms of same-parameter criterion.
+# The classified point is near to the edge. Therefore,
+# there is a dangerous to return ON-status. However, result must be IN.
+
+set Toler 1.0e-7
+
+binrestore [locate_data_file bug28211_planarface.bin] a
+
+fixshape result a
+checkshape result
+
+point pp 29.999999147417434 1971.5029199015287
+
+if { ![regexp {IN} [ b2dclassifx result pp -t $Toler] ] } {
+  puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+  puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {IN} [ b2dclassify result pp -t $Toler] ] } {
+  puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+  puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/classifier/bug28211_25 b/tests/lowalgos/classifier/bug28211_25
new file mode 100644
index 0000000..21f5963
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_25
@@ -0,0 +1,42 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# Check of work of polygonal classifier (CSLib_Class2d) when
+# the classified ray (which is parallel X-axis) goes through
+# some vertex of polygon 
+
+set px -24.5
+set py 26.2784601955168
+
+polyline pl 0 0 0 0 20 0 20 50 0 30 30 0 50 60 0 70 0 0 0 0 0
+mkplane result pl
+checkshape result
+
+point pp $px $py
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
+
+bounds result_3 u1 u2
+2dcvalue result_3 u1 xx yy
+
+if { [expr abs([dval yy]-$py)] > 1.0e-9} {
+  puts "Error: the classified ray (which is parallel X-axis) must go through some vertex of polygon."
+}
+
+if { ![regexp {OUT} [ b2dclassifx result pp] ] } {
+  puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+  puts "OK : Good result of 2d classifier algorithm"
+}
+
diff --git a/tests/lowalgos/classifier/bug28211_26 b/tests/lowalgos/classifier/bug28211_26
new file mode 100644
index 0000000..b165ca0
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_26
@@ -0,0 +1,42 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# Check of work of polygonal classifier (CSLib_Class2d) when
+# the classified ray (which is parallel X-axis) goes through
+# some vertex of polygon 
+
+set px -16.02
+set py 0.16052066682861
+
+polyline pl 0 0 0 30 10 0 50 30 0 100 30 0 100 -5 0 0 0 0
+mkplane result pl
+checkshape result
+
+point pp $px $py
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
+
+bounds result_2 u1 u2
+2dcvalue result_2 u1 xx yy
+
+if { [expr abs([dval yy]-$py)] > 1.0e-9} {
+  puts "Error: the classified ray (which is parallel X-axis) must go through some vertex of polygon."
+}
+
+if { ![regexp {IN} [ b2dclassifx result pp] ] } {
+  puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+  puts "OK : Good result of 2d classifier algorithm"
+}
+
diff --git a/tests/lowalgos/classifier/bug28211_27 b/tests/lowalgos/classifier/bug28211_27
new file mode 100644
index 0000000..124fbfb
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_27
@@ -0,0 +1,50 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# Check of work of polygonal classifier (CSLib_Class2d).
+# Especially for this case, aNullTolV local variable
+# has been added to SLib_Class2d::InternalClass(...) method.
+
+plane pl 0 -130 0 0 -1 0 1 0 0
+circle cc2 0 -130 0 0 -1 0 1 0 0 1026.5
+circle cc1 0 -130 0 0 -1 0 1 0 0 1145
+mkedge ee1 cc1
+mkedge ee2 cc2
+orientation ee2 R
+whatis ee1
+whatis ee2
+wire w1 ee1
+wire w2 ee2
+mkface result pl
+add w1 result
+add w2 result
+
+nbshapes result
+checkshape result
+
+point pp 268.78892051126780 990.82048099294911
+
+if { ![regexp {IN} [ b2dclassifx result pp ] ] } {
+  puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+  puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {IN} [ b2dclassify result pp ] ] } {
+  puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+  puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
\ No newline at end of file
diff --git a/tests/lowalgos/classifier/bug28211_28 b/tests/lowalgos/classifier/bug28211_28
new file mode 100644
index 0000000..b4c450b
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_28
@@ -0,0 +1,37 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# Check of work of polygonal classifier (CSLib_Class2d)
+# with the complex face.
+
+set Toler 1.0e-7
+
+binrestore [locate_data_file bug28211_complexface.bin] result
+checkshape result
+
+point pp -1.0880999999945753 3.7557000000000000
+
+if { ![regexp {IN} [ b2dclassifx result pp -t $Toler ] ] } {
+  puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+  puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {IN} [ b2dclassify result pp -t $Toler ] ] } {
+  puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+  puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
\ No newline at end of file
diff --git a/tests/lowalgos/classifier/bug28211_29 b/tests/lowalgos/classifier/bug28211_29
new file mode 100644
index 0000000..ad96140
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_29
@@ -0,0 +1,116 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# Another example of geometricaly not-closed face.
+# Principial factor in this case is to forbid 
+# use of polygonal classifier. If it launches, wrong result
+# will be obtained.
+
+plane pl 0 0 0 0 0 1
+bsplinecurve cc1 1 2 -0.105299999999371 2 0.10530000000008 2 2.31688587861 0 0 1 2.31688587861 0.1755 0 1 
+bsplinecurve cc2 1 2 0 2 2.31531201105 2 0 0.27 0 1 2.31688587861 0.27 0 1 
+bsplinecurve cc3 1 2 -0.10530000000008 2 0.105299999999371 2 0 0 0 1 0 0.1755 0 1
+bsplinecurve cc4 1 2 0 2 2.31531201105 2 0 0 0 1 2.31688587861 0 0 1
+mkedge e1 cc1
+mkedge e2 cc2
+mkedge e3 cc3
+mkedge e4 cc4
+
+explode e1 v
+copy e1_1 v1
+copy e1_2 v2
+explode e2 v
+copy e2_1 v3
+explode e3 v
+copy e3_1 v4
+
+emptycopy e1 e1
+emptycopy e2 e2
+emptycopy e3 e3
+emptycopy e4 e4
+
+orientation e1 F
+orientation e2 R
+orientation e3 R
+orientation e4 F
+
+# ---
+orientation v1 F
+orientation v2 R
+settolerance v2 0.1
+add v1 e1
+add v2 e1
+
+checknbshapes e1 -vertex 2 -edge 1
+if { ![regexp {FORWARD} [whatis e1] full] } {
+  puts "Error in e1 creation!"
+}
+
+# ---
+copy v2 v2c
+orientation v2c F
+orientation v3 R
+settolerance v3 0.1
+add v2c e2
+add v3 e2
+
+checknbshapes e2 -vertex 2 -edge 1
+if { ![regexp {REVERSED} [whatis e2] full] } {
+  puts "Error in e2 creation!"
+}
+
+# --
+copy v3 v3c
+orientation v3c F
+orientation v4 R
+add v3c e3
+add v4 e3
+
+checknbshapes e3 -vertex 2 -edge 1
+if { ![regexp {REVERSED} [whatis e3] full] } {
+  puts "Error in e3 creation!"
+}
+
+# --
+copy v4 v4c
+copy v1 v1c
+orientation v4c F
+orientation v1c R
+add v4c e4
+add v1c e4
+
+checknbshapes e4 -vertex 2 -edge 1
+if { ![regexp {FORWARD} [whatis e4] full] } {
+  puts "Error in e4 creation!"
+}
+
+wire ww e1 e2 e3 e4
+checknbshapes ww -vertex 4 -edge 4 -wire 1
+
+
+mkface result pl ww
+checkshape result
+
+point pp 2.3154730167575126 0.21264669107436251
+
+v2d
+pcurve result
+2dfit
+checkview -screenshot -2d -path ${imagedir}/${test_image}.png
+
+if { ![regexp {IN} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {IN} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
diff --git a/tests/lowalgos/classifier/bug28211_3 b/tests/lowalgos/classifier/bug28211_3
new file mode 100644
index 0000000..c92d9f8
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_3
@@ -0,0 +1,69 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# We create new face, which is not-closed in 2D-space.
+# This gap is covered by the tolerance of the vertex
+# and this vertex is shared between two edges.
+# After that, point is classified, which is
+# out of the face UV-bounds.
+
+box b1 10 10 1
+copy b1 b2
+btranslate b2 -10 0 0
+sewing bb b1 b2
+
+explode bb f
+
+explode bb_3 v
+copy bb_3_1 v1
+copy bb_3_2 v2
+copy bb_3_3 v3
+settolerance v3 1.5
+
+explode bb_3 e
+emptycopy e1 bb_3_1
+emptycopy e2 bb_3_2
+emptycopy e3 bb_3_4
+
+add v1 e1
+copy v1 v1c
+orientation v1c F
+
+add v2 e1
+copy v2 v2c
+orientation v2c R
+
+add v1c e2
+add v3 e2
+copy v3 v3c
+orientation v3c F
+
+add v3c e3
+add v2c e3
+
+wire w1 e1 e2 e3
+
+buildfaces f1 bb_3 w1
+explode f1 f
+copy f1_1 result
+
+checkshape result
+
+point pp 0.5 -20
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of b2dclassifx algorithm"
+} else {
+    puts "OK : Good result of b2dclassifx algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of b2dclassify algorithm"
+} else {
+    puts "OK : Good result of b2dclassify algorithm"
+}
diff --git a/tests/lowalgos/classifier/bug28211_30 b/tests/lowalgos/classifier/bug28211_30
new file mode 100644
index 0000000..0191e01
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_30
@@ -0,0 +1,34 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# Check of work of polygonal classifier (CSLib_Class2d).
+# The result must be ON.
+
+set px  1513.57217669793
+set py -10.1029426238323
+
+2dpolyline result 1513.57217669793 11.0973538037081 -1051.81650575747 6.73452567267988 -1051.8152777319 6.00321559118616 -1051.80401237154 -0.66964148152312 -1051.79153179272 -8.00754731710954 -1051.78462891576 -12.0435532938874 -1051.7792064627 -15.1970808363544 1513.60824796713 -10.1029426238323 1513.6062129155 -8.92173663981858 1513.60388800065 -7.56876388778882 1513.60082451782 -5.78147799036545 1513.59744872383 -3.80726865383441 1513.59384827412 -1.69716087791358 1513.590129038 0.486912960705931 1513.58640596764 2.67747973139385 1513.582793967 4.80689217261492 1513.57903892674 7.02554393157767 1513.57532192993 9.22774787864227 1513.57217669793 11.0973538037081
+
+
+set log [polyclassify -s -c $px $py -t 0.0256560053668387 0.0256560053668387 -p result ]
+
+if { ![regexp {ON} $log ] } {
+  puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+  puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+point p1 1513.4 -10.2
+point p2 1513.6 -9.8
+2dfit
+point pntsrc $px $py
+donly result pntsrc
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
\ No newline at end of file
diff --git a/tests/lowalgos/classifier/bug28211_31 b/tests/lowalgos/classifier/bug28211_31
new file mode 100644
index 0000000..8968ee6
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_31
@@ -0,0 +1,38 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# Check of correct definition of ON-status if 3D- and 2D-
+# curve of edge (which the source point is in) is significant
+# greater than the input tolerance for classifier.
+
+set Toler 1.0e-7
+
+restore [locate_data_file bug28211_fiton.brep] result
+checkshape result
+
+point pp 0.42782232233104311 1.0000000346609297
+
+if { ![regexp {ON} [ b2dclassifx result pp -t $Toler ] ] } {
+  puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+  puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {ON} [ b2dclassify result pp -t $Toler ] ] } {
+  puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+  puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
\ No newline at end of file
diff --git a/tests/lowalgos/classifier/bug28211_32 b/tests/lowalgos/classifier/bug28211_32
new file mode 100644
index 0000000..267474e
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_32
@@ -0,0 +1,61 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The classified face is based on the sphere and seems to be valid.
+# As far as we know, the sphere is not periodic in V-direction.
+# However, its equation contains only periodic trigonometric
+# function of V (x=f1(U)*cos(V), y=f2(U)*cos(V), z=R*sin(V),
+# where f1(U) and f2(U) are some (periodic) functions with
+# argument U, R is the radius of the sphere). Therefore,
+# if we decline to limit V-range of the sphere in the traditional
+# boundaries [-pi/2; +pi/2] the sphere will be true periodic in V-direction.
+# So, despite taking the classified point pp too far from the face domain
+# (in V-direction) it will be "converted" to the valid 3D-point ON the
+# some edge of the classified face. As result, there is a danger
+# to return ON-status from the classification algorithm. However,
+# it must return OUT.
+# Classified point is near to the sphere apex (in 3D-space)
+
+restore [locate_data_file bug28211_spherepole.brep] result
+
+checkshape result
+
+set px 3.14159265358979
+set py 1.57079634
+
+point pp $px $py
+
+mksurface ss result
+svalue ss $px $py xx yy zz
+vertex vv xx yy zz
+
+smallview 
+donly result vv
+fit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_3d.png
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/classifier/bug28211_33 b/tests/lowalgos/classifier/bug28211_33
new file mode 100644
index 0000000..78f8785
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_33
@@ -0,0 +1,50 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The classified face is based on the sphere and seems to be valid.
+# Classified point is near to the sphere apex.
+# So, result must be ON.
+
+restore [locate_data_file bug28211_spherepole.brep] result
+
+checkshape result
+
+set px 6.28318531
+set py 1.57079634
+
+point pp $px $py
+
+mksurface ss result
+svalue ss $px $py xx yy zz
+vertex vv xx yy zz
+
+smallview 
+donly result vv
+fit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_3d.png
+
+if { ![regexp {ON} [ b2dclassifx result pp -t 1.0e-7 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {ON} [ b2dclassify result pp -t 1.0e-7 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/classifier/bug28211_34 b/tests/lowalgos/classifier/bug28211_34
new file mode 100644
index 0000000..843cf61
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_34
@@ -0,0 +1,62 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The classified face is based on the sphere and seems to be valid.
+# As far as we know, the sphere is not periodic in V-direction.
+# However, its equation contains only periodic trigonometric
+# function of V (x=f1(U)*cos(V), y=f2(U)*cos(V), z=R*sin(V),
+# where f1(U) and f2(U) are some (periodic) functions with
+# argument U, R is the radius of the sphere). Therefore,
+# if we decline to limit V-range of the sphere in the traditional
+# boundaries [-pi/2; +pi/2] the sphere will be true periodic in V-direction.
+# So, despite taking the classified point pp too far from the face domain
+# (in V-direction) it will be "converted" to the valid 3D-point ON the
+# some edge of the classified face. As result, there is a danger
+# to return ON-status from the classification algorithm. However,
+# it must return OUT.
+# Moreover, the source face is based on the offset surface
+# (basis surface is sphere).
+
+restore [locate_data_file bug28211_sphereoffset.brep] result
+
+checkshape result
+
+set px pi
+set py -2.9878952687994853
+
+point pp $px $py
+
+mksurface ss result
+svalue ss $px $py xx yy zz
+vertex vv xx yy zz
+
+smallview 
+donly result vv
+fit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_3d.png
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/classifier/bug28211_35 b/tests/lowalgos/classifier/bug28211_35
new file mode 100644
index 0000000..532d219
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_35
@@ -0,0 +1,60 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The classified face is based on the sphere and seems to be valid.
+# As far as we know, the sphere is not periodic in V-direction.
+# However, its equation contains only periodic trigonometric
+# function of V (x=f1(U)*cos(V), y=f2(U)*cos(V), z=R*sin(V),
+# where f1(U) and f2(U) are some (periodic) functions with
+# argument U, R is the radius of the sphere). Therefore,
+# if we decline to limit V-range of the sphere in the traditional
+# boundaries [-pi/2; +pi/2] the sphere will be true periodic in V-direction.
+# So, despite taking the classified point pp too far from the face domain
+# (in V-direction) it will be "converted" to the valid 3D-point ON the
+# some edge of the classified face. As result, there is a danger
+# to return ON-status from the classification algorithm. However,
+# it must return OUT.
+
+restore [locate_data_file bug28211_sphseam.brep] result
+
+checkshape result
+
+set px pi
+set py -2.9878952687994853
+
+point pp $px $py
+
+mksurface ss result
+svalue ss $px $py xx yy zz
+vertex vv xx yy zz
+
+smallview 
+donly result vv
+fit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_3d.png
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/classifier/bug28211_36 b/tests/lowalgos/classifier/bug28211_36
new file mode 100644
index 0000000..b846d8d
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_36
@@ -0,0 +1,54 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The classified face is based on surface of revolution (based on ellipse).
+# Such surface can be considered as periodic (see pictures).
+# So, despite taking the classified point pp too far from the face domain
+# (in V-direction) it will be "converted" to the valid 3D-point ON the
+# some edge of the classified face. As result, there is a danger
+# to return ON-status from the classification algorithm. However,
+# it must return OUT.
+
+restore [locate_data_file bug28211_revfaceon.brep] result
+
+checkshape result
+
+set px pi
+set py -0.1
+
+point pp $px $py
+
+mksurface ss result
+svalue ss $px $py xx yy zz
+vertex vv xx yy zz
+
+smallview 
+donly result vv
+fit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_3d.png
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/classifier/bug28211_37 b/tests/lowalgos/classifier/bug28211_37
new file mode 100644
index 0000000..77821be
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_37
@@ -0,0 +1,50 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# This case differs from bug28211_34 by that the fase is
+# based on trimmed surface.
+# So, result must be OUT (as in bug28211_34 test case).
+
+restore [locate_data_file bug28211_spheretrpole.brep] result
+
+checkshape result
+
+set px 6.28318531
+set py 1.57079634
+
+point pp $px $py
+
+mksurface ss result
+svalue ss $px $py xx yy zz
+vertex vv xx yy zz
+
+smallview 
+donly result vv
+fit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_3d.png
+
+if { ![regexp {OUT} [ b2dclassifx result pp -t 1.0e-7 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp -t 1.0e-7 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/classifier/bug28211_38 b/tests/lowalgos/classifier/bug28211_38
new file mode 100644
index 0000000..21a5944
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_38
@@ -0,0 +1,50 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# This case differs from bug28211_33 by that the fase is
+# based on trimmed surface.
+# So, result must be ON (as in bug28211_33 test case).
+
+restore [locate_data_file bug28211_spheretrpole.brep] result
+
+checkshape result
+
+set px 3.14159266
+set py 1.57079634
+
+point pp $px $py
+
+mksurface ss result
+svalue ss $px $py xx yy zz
+vertex vv xx yy zz
+
+smallview 
+donly result vv
+fit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_3d.png
+
+if { ![regexp {ON} [ b2dclassifx result pp -t 1.0e-7 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {ON} [ b2dclassify result pp -t 1.0e-7 ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/classifier/bug28211_39 b/tests/lowalgos/classifier/bug28211_39
new file mode 100644
index 0000000..6daacd9
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_39
@@ -0,0 +1,62 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The classified face is based on the sphere and seems to be valid.
+# As far as we know, the sphere is not periodic in V-direction.
+# However, its equation contains only periodic trigonometric
+# function of V (x=f1(U)*cos(V), y=f2(U)*cos(V), z=R*sin(V),
+# where f1(U) and f2(U) are some (periodic) functions with
+# argument U, R is the radius of the sphere). Therefore,
+# if we decline to limit V-range of the sphere in the traditional
+# boundaries [-pi/2; +pi/2] the sphere will be true periodic in V-direction.
+# So, despite taking the classified point pp too far from the face domain
+# (in V-direction) it will be "converted" to the valid 3D-point ON the
+# some edge of the classified face. As result, there is a danger
+# to return ON-status from the classification algorithm. However,
+# it must return OUT.
+# Moreover, the source face is based on the offset surface
+# (basis surface is sphere).
+
+restore [locate_data_file bug28211_sphereoffset.brep] result
+
+checkshape result
+
+set px 0
+set py [dval 2*pi]
+
+point pp $px $py
+
+mksurface ss result
+svalue ss $px $py xx yy zz
+vertex vv xx yy zz
+
+smallview 
+donly result vv
+fit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_3d.png
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
